%define major 2
%define libname %mklibname sasl %{major}
%define up_name cyrus-sasl
%define sasl2_db_filename /var/lib/sasl2/sasl.db

%define MYSQL 1
%define SRP 0
%define PGSQL 0
%define SQLITE 0
%define LDAP 1
%define SRPSTR disabled
%define MYSQLSTR enabled
%define PGSQLSTR disabled
%define SQLITESTR disabled
%define LDAPSTR enabled

%ifarch %{ix86}
%define __cc i586-mandriva-linux-gnu-gcc
%endif

%{?_with_srp: %{expand: %%global SRP 1}}
%{?_without_srp: %{expand: %%global SRP 0}}
%{?_with_mysql: %{expand: %%global MYSQL 1}}
%{?_without_mysql: %{expand: %%global MYSQL 0}}
%{?_with_pgsql: %{expand: %%global PGSQL 1}}
%{?_without_pgsql: %{expand: %%global PGSQL 0}}
%{?_with_sqlite: %{expand: %%global SQLITE 1}}
%{?_without_sqlite: %{expand: %%global SQLITE 0}}
%{?_with_ldap: %{expand: %%global LDAP 1}}
%{?_without_ldap: %{expand: %%global LDAP 0}}

%{?_with_srp: %{expand: %%global SRPSTR enabled}}
%{?_without_srp: %{expand: %%global SRPSTR disabled}}
%{?_with_mysql: %{expand: %%global MYSQLSTR enabled}}
%{?_without_mysql: %{expand: %%global MYSQLSTR disabled}}
%{?_with_pgsql: %{expand: %%global PGSQLSTR enabled}}
%{?_without_pgsql: %{expand: %%global PGSQLSTR disabled}}
%{?_with_sqlite: %{expand: %%global SQLITESTR enabled}}
%{?_without_sqlite: %{expand: %%global SQLITESTR disabled}}
%{?_with_ldap: %{expand: %%global LDAPSTR enabled}}
%{?_without_ldap: %{expand: %%global LDAPSTR disabled}}

# bootstrapping overrides the above LDAP defines
%{?bootstrap: %{expand: %%global LDAP 0}}
%{?bootstrap: %{expand: %%global LDAPSTR disabled}}

Summary:	The Simple Authentication and Security Layer
Name:		%{up_name}
Version:	2.1.23
Release:	%mkrel 3
Source0:	ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/%{up_name}-%{version}.tar.xz
Source2:	saslauthd.init
Source3:	saslauthd.sysconfig
Source4:	service.conf.example
Source7:	sasl-mechlist.c
Source8:	sasl-checkpass.c
Patch0:		cyrus-sasl-doc.patch
Patch1:		cyrus-sasl-2.1.15-lib64.patch
Patch2:		cyrus-sasl-2.1.20-gssapi-dynamic.patch
Patch3:		cyrus-sasl-2.1.19-pic.patch
Patch4:		cyrus-sasl-2.1.22-sed_syntax.diff
Patch5:		0006_library_mutexes.dpatch
Patch6:		0012_xopen_crypt_prototype.dpatch

# synced with fedora
Patch11:	cyrus-sasl-2.1.18-no_rpath.patch
Patch23:	cyrus-sasl-2.1.23-man.patch
Patch24:	cyrus-sasl-2.1.21-sizes.patch
Patch25:	cyrus-sasl-2.1.22-typo.patch
Patch26:	cyrus-sasl-2.1.22-digest-commas.patch
Patch27:	cyrus-sasl-2.1.22-automake-1.10.patch
Patch28:	cyrus-sasl-2.1.21-keytab.patch
Patch30:	cyrus-sasl-2.1.22-rimap.patch
Patch31:	cyrus-sasl-2.1.22-kerberos4.patch
Patch32:	cyrus-sasl-2.1.22-warnings.patch
Patch33:	cyrus-sasl-2.1.22-current-db.patch
Patch34:	cyrus-sasl-2.1.22-ldap-timeout.patch
Patch35:	cyrus-sasl-2.1.22-bad-elif.patch
Patch36:	cyrus-sasl-ac-quote.patch
Patch37:	cyrus-sasl-2.1.23-race.patch

License:	BSD-style
Group:		System/Libraries
URL:		http://asg.web.cmu.edu/cyrus/download/
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
Requires:	%{libname} = %{version}
Requires(pre):	rpm-helper
Requires(post):	rpm-helper
Requires(preun): rpm-helper
BuildRequires:	autoconf
BuildRequires:	db4-devel
BuildRequires:	pam-devel
BuildRequires:	openssl-devel >= 0.9.6a
BuildRequires:	libtool >= 1.4
BuildRequires:	krb5-devel >= 1.4.1
%if %{MYSQL}
BuildRequires:	mysql-devel
%endif
%if %{PGSQL}
BuildRequires:	postgresql-devel
%endif
%if %{SQLITE}
BuildRequires:	sqlite-devel
%endif
%if %{LDAP}
BuildRequires:	openldap-devel
%endif
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
SASL is the Simple Authentication and Security Layer, 
a method for adding authentication support to connection-based protocols. 
To use SASL, a protocol includes a command for identifying and authenticating 
a user to a server and for optionally negotiating protection of subsequent 
protocol interactions. If its use is negotiated, a security layer is inserted 
between the protocol and the connection. 
To actually use SASL you must install at least one of the %{libname}-plug-XXXX
authentication plugin, such as %{libname}-plug-plain.
The SQL auxprop plugin can be rebuild with different database backends:
	--with srp	SRP support	(%{SRPSTR})
	--with mysql	MySQL support	(%{MYSQLSTR})
	--with pgsql	Postgres SQL support	(%{PGSQLSTR})
	--with sqlite	SQLite support	(%{SQLITESTR})

%package -n	%{libname}
Summary:	Libraries for SASL a the Simple Authentication and Security Layer
Group:		System/Libraries

%description -n	%{libname}
SASL is the Simple Authentication and Security Layer, 
a method for adding authentication support to connection-based protocols. 
To use SASL, a protocol includes a command for identifying and authenticating 
a user to a server and for optionally negotiating protection of subsequent 
protocol interactions. If its use is negotiated, a security layer is inserted 
between the protocol and the connection. 

%package -n	%{libname}-devel
Summary:	Libraries for SASL a the Simple Authentication and Security Layer
Group:		Development/C
%if %{_lib} != lib
Provides:	libsasl-devel = %{version}
Provides:	libsasl2-devel = %{version}
%endif
Provides:	%{mklibname -d sasl} = %{version}
Requires:	%{libname} = %{version}

%description -n	%{libname}-devel
SASL is the Simple Authentication and Security Layer, 
a method for adding authentication support to connection-based protocols. 
To use SASL, a protocol includes a command for identifying and authenticating 
a user to a server and for optionally negotiating protection of subsequent 
protocol interactions. If its use is negotiated, a security layer is inserted 
between the protocol and the connection. 

%package -n	%{libname}-plug-anonymous
Summary:	SASL ANONYMOUS mechanism plugin
Group:		System/Libraries
Requires:	%{libname} = %{version}
Provides:	sasl-plug-anonymous

%description -n	%{libname}-plug-anonymous
This plugin implements the SASL ANONYMOUS mechanism,
used for anonymous authentication.

%package -n	%{libname}-plug-crammd5
Summary:	SASL CRAM-MD5 mechanism plugin
Group:		System/Libraries
Requires:	%{libname} = %{version}
Provides:	sasl-plug-crammd5

%description -n	%{libname}-plug-crammd5
This plugin implements the SASL CRAM-MD5 mechanism.
CRAM-MD5 is the mandatory-to-implement authentication mechanism for a
number of protocols; it uses MD5 with a challenge/response system to
authenticate the user.

%package -n	%{libname}-plug-digestmd5
Summary:	SASL DIGEST-MD5 mechanism plugin
Group:		System/Libraries
Requires:	%{libname} = %{version}
Provides:	sasl-plug-digestmd5

%description -n	%{libname}-plug-digestmd5
This plugin implements the latest draft of the SASL DIGEST-MD5
mechanism.  Although not yet finalized, this is likely to become the
new mandatory-to-implement authentication system in all new protocols.
It's based on the digest md5 authentication system designed for HTTP.

%package -n	%{libname}-plug-plain
Summary:	SASL PLAIN mechanism plugin
Group:		System/Libraries
Requires:	%{libname} = %{version}
Provides:	sasl-plug-plain

%description -n	%{libname}-plug-plain
This plugin implements the SASL PLAIN mechanism.  Although insecure,
PLAIN is useful for transitioning to new security mechanisms, as this
is the only mechanism which gives the server a copy of the user's
password.

%package -n	%{libname}-plug-login
Summary:	SASL LOGIN mechanism plugin
Group:		System/Libraries
Requires:	%{libname} = %{version}
Provides:	sasl-plug-login

%description -n	%{libname}-plug-login
This plugin implements the SASL LOGIN mechanism.
THIS PLUGIN IS DEPRECATED, is maintained only for compatibility reasons 
and will be dropped soon.
Please use the plain plugin instead.

%package -n	%{libname}-plug-gssapi
Summary:	SASL GSSAPI mechanism plugin
Group:		System/Libraries
Requires:	%{libname} = %{version}
Requires:	krb5-libs
Provides:	sasl-plug-gssapi

%description -n	%{libname}-plug-gssapi
This plugin implements the SASL GSSAPI (kerberos 5)mechanism.

%package -n	%{libname}-plug-otp
Summary:	SASL OTP mechanism plugin
Group:		System/Libraries
Requires:	%{libname} = %{version}
Provides:	sasl-plug-otp

%description -n	%{libname}-plug-otp
This plugin implements the SASL OTP mechanism.

%package -n	%{libname}-plug-sasldb
Summary:	SASL sasldb auxprop plugin
Group:		System/Libraries
Requires(post):	%{name} >= %{version}
Requires:	%{libname} = %{version}, %{name} >= %{version}
Provides:	sasl-plug-sasldb

%description -n	%{libname}-plug-sasldb
This package provides the SASL sasldb auxprop plugin, which stores secrets
in a Berkeley database file.

%if %{SRP}
%package -n	%{libname}-plug-srp
Summary:	SASL srp mechanism plugin
Group:		System/Libraries
Requires:	%{libname} = %{version}
Provides:	sasl-plug-srp

%description -n	%{libname}-plug-srp
This plugin implements the srp  mechanism.
%endif

%package -n	%{libname}-plug-ntlm
Summary:	SASL ntlm authentication plugin
Group:		System/Libraries
Requires:	%{libname} = %{version}
Provides:	sasl-plug-ntlm

%description -n	%{libname}-plug-ntlm
This plugin implements the (unsupported) ntlm authentication.

%if %{MYSQL} || %{PGSQL} || %{SQLITE}
%package -n	%{libname}-plug-sql
Summary:	SASL sql auxprop plugin
Group:		System/Libraries
Requires:	%{libname} = %{version}
Provides:	sasl-plug-sql

%description -n	%{libname}-plug-sql
This plugin implements the SQL auxprop authentication method
It can be rebuild with different database backends:
	--with mysql	MySQL support	(%{MYSQLSTR})
	--with pgsql	Postgres SQL support	(%{PGSQLSTR})
	--with sqlite	SQLite support	(%{SQLITESTR})
%endif

%if %{LDAP}
%package -n	%{libname}-plug-ldapdb
Summary:	SASL ldapdb auxprop plugin
Group:		System/Libraries
Requires:	%{libname} = %{version}
Provides:	sasl-plug-ldapdb

%description -n	%{libname}-plug-ldapdb
This plugin implements the LDAP auxprop authentication method.
%endif

%prep
%setup -q -n %{up_name}-%{version}
install -m 0644 %{SOURCE4} .
%patch0 -p1 -b .sasldoc~
%patch1 -p1 -b .lib64~
%patch3 -p1 -b .pic~
%patch4 -p0 -b .sed_syntax~
%patch5 -p1 -b .library_mutexes~
%patch6 -p1 -b .xopen_crypt_prototype~
%patch11 -p1 -b .no_rpath~
%patch23 -p1 -b .man~
%patch24 -p1 -b .sizes~
%patch25 -p1 -b .typo~
%patch26 -p2 -b .digest-commas~
%patch27 -p1 -b .automake-1.10~
%patch28 -p1 -b .keytab~
%patch30 -p1 -b .rimap~
%patch31 -p1 -b .krb4~
%patch32 -p1 -b .warnings~
%patch33 -p1 -b .current-db~
%patch34 -p1 -b .ldap-timeout~
%patch35 -p1 -b .elif~
%patch36 -p1 -b .ac-quote~
%patch37 -p1 -b .race~

cp %{SOURCE7} sasl-mechlist.c
cp %{SOURCE8} sasl-checkpass.c

rm -f config/config.guess config/config.sub 
rm -f config/ltconfig config/ltmain.sh config/libtool.m4
rm -fr autom4te.cache
libtoolize -c
aclocal -I config -I cmulocal
automake -a -c
autoheader
autoconf
pushd saslauthd
rm -f config/ltconfig
libtoolize -f -c
aclocal -I ../config -I ../cmulocal
automake -a -c -f
autoheader
autoconf -f
popd

%build

%serverbuild
%{?__cputoolize: %{__cputoolize} -c saslauthd}
%configure2_5x 	--enable-static --enable-shared \
		--with-plugindir=%{_libdir}/sasl2 \
		--with-configdir=%{_sysconfdir}/sasl2:%{_libdir}/sasl2 \
		--disable-krb4 \
		--enable-login \
%if %{SRP}
		--enable-srp --enable-srp-setpass \
%else
		--without-srp --without-srp-srp-setpass \
%endif
		--enable-ntlm \
		--enable-db4 \
		--enable-gssapi \
		--disable-gss_mutexes \
%if %{MYSQL}
		--enable-sql --with-mysql=%{_prefix} \
%else
		--without-mysql \
%endif
%if %{PGSQL}
		--enable-sql --with-pgsql=%{_prefix} \
%else
		--without-pgsql \
%endif
%if %{SQLITE}
		--enable-sql --with-sqlite=%{_prefix} \
%else
		--without-sqlite \
%endif
%if %{LDAP}
		--with-ldap=%{_prefix} \
		--enable-ldapdb \
%endif
		--with-dbpath=%{sasl2_db_filename} \
		--with-saslauthd=/var/run/saslauthd \
		--with-authdaemond=/var/run/authdaemon.courier-imap/socket


make || :
make
make -C saslauthd testsaslauthd
make -C sample

install saslauthd/LDAP_SASLAUTHD README.ldap


# Build a small program to list the available mechanisms, because I need it.
pushd lib
    ../libtool --tag=CC --mode=link %{__cc} -o sasl2-shared-mechlist \
	-I../include $CFLAGS ../sasl-mechlist.c $LDFLAGS ./libsasl2.la
    ../libtool --tag=CC --mode=link %{__cc} -o sasl2-shared-checkpass \
	-I../include $CFLAGS -DSASL2 ../sasl-checkpass.c $LDFLAGS ./libsasl2.la
popd

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/var/lib/sasl2 %{buildroot}/var/run/saslauthd
mkdir -p %{buildroot}%{_sysconfdir}/sasl2
%makeinstall_std

install -m644 %{SOURCE2} -D %{buildroot}%{_initrddir}/saslauthd
install -m644 %{SOURCE3} -D %{buildroot}%{_sysconfdir}/sysconfig/saslauthd

# we don't need these
find %{buildroot} -name *.la -delete
find %{buildroot} -name *.a -delete

# dbconverter-2 isn't installed by make install

cd utils
/bin/sh ../libtool --mode=install /usr/bin/install -c dbconverter-2 \
  %{buildroot}/%{_sbindir}/dbconverter-2

cd ..
cp saslauthd/testsaslauthd %{buildroot}%{_sbindir}
cd sample
/bin/sh ../libtool --mode=install /usr/bin/install -c client \
  %{buildroot}/%{_sbindir}/sasl-sample-client
/bin/sh ../libtool --mode=install /usr/bin/install -c server \
  %{buildroot}/%{_sbindir}/sasl-sample-server
cd ..

# multiarch policy
%multiarch_includes %{buildroot}%{_includedir}/sasl/md5global.h

# This is just to "close" vim's syntax misinterpretation.. ;p

# Provide an easy way to query the list of available mechanisms.
./libtool --tag=CC --mode=install install -m0755 lib/sasl2-shared-mechlist %{buildroot}%{_sbindir}/
./libtool --tag=CC --mode=install install -m0755 lib/sasl2-shared-checkpass %{buildroot}%{_sbindir}/

rm -rf %{buildroot}%{_datadir}/cyrus-sasl-2.1.23

%clean
rm -rf %{buildroot}

%pre -n %{libname}-plug-sasldb
%_pre_groupadd sasl

%post -n %{libname}-plug-sasldb
#convert old sasldb
# XXX - what about berkeley db versions? - andreas
if [ -f /var/lib/sasl/sasl.db -a ! -f %{sasl2_db_filename} ]; then
	echo "" | /usr/sbin/dbconverter-2 /var/lib/sasl/sasl.db %{sasl2_db_filename}
	if [ -f %{sasl2_db_filename} ]; then
		# conversion was successfull
		chmod 0640 %{sasl2_db_filename}
		chown root:sasl %{sasl2_db_filename}
	fi
fi
if [ -f /var/lib/sasl/sasl.db.rpmsave -a ! -f %{sasl2_db_filename} ]; then
	echo "" | /usr/sbin/dbconverter-2 /var/lib/sasl/sasl.db.rpmsave %{sasl2_db_filename}
	if [ -f %{sasl2_db_filename} ]; then
		# conversion was successfull
		chmod 0640 %{sasl2_db_filename}
		chown root:sasl %{sasl2_db_filename}
	fi
fi
if [ ! -f %{sasl2_db_filename} ]; then
	# the file was never created before nor converted from sasl1
	touch %{sasl2_db_filename}
	chmod 0640 %{sasl2_db_filename}
	chown root:sasl %{sasl2_db_filename}
fi

%post
%_post_service saslauthd

%preun
%_preun_service saslauthd

%files
%defattr(-,root,root)
%dir /var/lib/sasl2
%dir /var/run/saslauthd
%attr (755,root,root) %{_initrddir}/saslauthd
%dir %{_sysconfdir}/sasl2
%attr (644,root,root) %config(noreplace) %{_sysconfdir}/sysconfig/saslauthd
%exclude %{_sbindir}/sasl2-shared-mechlist
%exclude %{_sbindir}/sasl2-shared-checkpass
%{_sbindir}/*
%{_mandir}/man8/*

%files -n %{libname}
%defattr(-,root,root)
%dir %{_libdir}/sasl2
%{_libdir}/libsasl*.so.*

%files -n %{libname}-plug-anonymous
%defattr(-,root,root)
%{_libdir}/sasl2/libanonymous*.so*

%files -n %{libname}-plug-otp
%defattr(-,root,root)
%{_libdir}/sasl2/libotp*.so*

%files -n %{libname}-plug-sasldb
%defattr(-,root,root)
%{_libdir}/sasl2/libsasldb*.so*

%files -n %{libname}-plug-gssapi
%defattr(-,root,root)
%{_libdir}/sasl2/libgssapi*.so*

%files -n %{libname}-plug-crammd5
%defattr(-,root,root)
%{_libdir}/sasl2/libcrammd5*.so*

%files -n %{libname}-plug-digestmd5
%defattr(-,root,root)
%{_libdir}/sasl2/libdigestmd5*.so*

%files -n %{libname}-plug-plain
%defattr(-,root,root)
%{_libdir}/sasl2/libplain*.so*

%files -n %{libname}-plug-login
%defattr(-,root,root)
%{_libdir}/sasl2/liblogin*.so*

%if %{SRP}
%files -n %{libname}-plug-srp
%defattr(-,root,root)
%{_libdir}/sasl2/libsrp*.so*
%endif

%files -n %{libname}-plug-ntlm
%defattr(-,root,root)
%{_libdir}/sasl2/libntlm*.so*

%if %{MYSQL} || %{PGSQL} || %{SQLITE}
%files -n %{libname}-plug-sql
%defattr(-,root,root)
%{_libdir}/sasl2/libsql*.so*
%endif

%if %{LDAP}
%files -n %{libname}-plug-ldapdb
%defattr(-,root,root)
%{_libdir}/sasl2/libldap*.so*
%endif

%files -n %{libname}-devel
%defattr(-,root,root)
%{_sbindir}/sasl2-shared-mechlist
%{_sbindir}/sasl2-shared-checkpass
%{_includedir}/*
%{_libdir}/*.*so
%{_mandir}/man3/*

%changelog
* Mon Jun 02 2013 Texstar <texstar at gmail.com> 2.1.23-3pclos2013
- rebuild for new gcc/glibc and remove .la and .a files

* Thu Sep 09 2010 Texstar <texstar at gmail.com> 2.1.23-2pclos2010
- rebuild ldap

* Fri Jul 23 2010 Texstar <texstar at gmail.com> 2.1.23-1pclos2010
- 2.1.23

